
<!DOCTYPE html>

<html lang="it">
  <head>
    <meta charset="utf-8" />
    <title>Installazione di Spinx &#8212; Introduzione a Sphinx 1.0.0 documentazione</title>
    <link rel="stylesheet" href="../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    <script src="../_static/translations.js"></script>
    <link rel="index" title="Indice" href="../genindex.html" />
    <link rel="search" title="Cerca" href="../search.html" />
    <link rel="next" title="Scrivere la documentazione" href="scrivere.html" />
    <link rel="prev" title="Premessa" href="premessa.html" />
   
  <link rel="stylesheet" href="../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <div class="section" id="installazione-di-spinx">
<h1>Installazione di Spinx<a class="headerlink" href="#installazione-di-spinx" title="Link a questa intestazione">¶</a></h1>
<p>In questa breve presentazione illustriamo come installare Sphinx e preparare
un nuovo progetto di documentazione.</p>
<p>Sphinx è una libreria python ed i comandi necessari devono essere impartiti
da terminale. Questo non è un corso su python, quindi non mi dilungo sul
significato dei comandi python sui quali invito tutti ad approfondire in
proprio.</p>
<p>Python è multi piattaforma e Sphinx funziona su tutte le piattaforme, ma i
comandi possono essere leggermente diversi, in questo tutorial useremo come
ambiente di riferimento Python 3.6 su Linux Ubuntu 18.04, ma i comandi
dovrebbero essere uguali su tutti i sistemi basati su Debian.</p>
<p>Per le altre piattaforme non è difficile trovare i comandi equivalenti facendo
una piccola ricerca.</p>
<div class="section" id="installazione">
<h2>Installazione<a class="headerlink" href="#installazione" title="Link a questa intestazione">¶</a></h2>
<p>Incominciamo. Prima di tutto vediamo se abbiamo Python e tutto quello che
serve.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ sudo apt install python3
$ sudo apt install python3-dev
$ sudo apt install python3-pip
$ sudo apt install python3-venv
</pre></div>
</div>
<p>Molto probabilmente python3 è gia installato, ma pip e venv potrebbero non
esserlo.</p>
<p>Ora creiamo una directory e prepariamo il nostro progetto:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ cd ~
$ mkdir sphinxdoc
$ cd sphinxdoc
$ python3 -m venv venv
$ source venv/bin/activate
$ pip install -U pip
$ pip install sphinx
$ pip install recommonmark
$ pip install sphinxcontrib.websupport
</pre></div>
</div>
<p>Con questi comandi abbiamo creato un ambiente virtuale isolato che evita
conflitti con altre eventuali istanze di python. Ed abbiamo anche installato
tutto ciò che ci serve per partire. Se serviranno altre librerie le
installeremo in seguito.</p>
<p>L'ambiente è creato, se ora usciamo del terminale, la prossima volta che
rientriamo ci sarà sufficiente dare i comandi:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ cd ~
$ cd sphinxdoc
$ python3 -m venv venv
$ source venv/bin/activate
</pre></div>
</div>
</div>
<div class="section" id="il-primo-progetto">
<h2>Il primo progetto<a class="headerlink" href="#il-primo-progetto" title="Link a questa intestazione">¶</a></h2>
<p>A questo punto possiamo creare il nostro progetto:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ mkdir mydoc
$ cd mydoc
$ sphinx-quickstart
</pre></div>
</div>
<p>Ora la macchina ci chiede alcune informazioni. Possiamo inserire i dati
senza problemi anche perché se dovessimo cambiare idea possiamo sempre andare
a modificare il file di configurazione che è stato creato.</p>
<p>Alla fine il sistema avrà scritto un po' di files che sono sufficienti per
compilare il nostro primo progetto funzionante. Se digitiamo:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ make
</pre></div>
</div>
<p>Sphinx ci elenca la lista dei formati di documentazione che è in grado di
creare, per alcuni di questi però sono necessarie ulteriori configurazioni.</p>
<p>Per creare un sito html digitiamo:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ make html
</pre></div>
</div>
<p>Se non ci sono errori vengono compilati i sorgenti per produrre il
risultato finale. Possiamo aprire il sito con:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ cd _build/html/
$ firefox index.html
</pre></div>
</div>
<p>e dovremmo vedere la nostra home page della documentazione. Naturalmente
invece che aprire firefox da terminale, possiamo aprire le cartelle da
interfaccia grafica e fare doppio click su <cite>index.html</cite>.</p>
</div>
<div class="section" id="markdown-e-pandoc">
<h2>Markdown e Pandoc<a class="headerlink" href="#markdown-e-pandoc" title="Link a questa intestazione">¶</a></h2>
<p>Ora possiamo iniziare ad aggiungere qualche contenuto. Ma prima torniamo a
parlare di markdown un momento.</p>
<p>In <a class="reference internal" href="premessa.html#md-ref"><span class="std std-ref">precedenza</span></a> avevamo detto che sphinx makrdown con alcune
limitazioni. Avevamo parlato anche di <a class="reference internal" href="premessa.html#pandoc-ref"><span class="std std-ref">Pandoc</span></a> che è in grado di
tradurre in vari formati, quindi direi che possiamo fare una prova.</p>
<p>Prima di tutto se non lo abbiamo già, installiamo Pandoc con:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ sudo apt install pandoc
</pre></div>
</div>
<p>Scriviamo quindi una piccola pagina di nome <cite>test.md</cite> con questo contenuto:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span># Prova di un testo

Usiamo alcuni **metalinguaggi** per scrivere html in forma leggibile e semplificata

Ecco alcuni esempi:

- [markdown](https://www.markdownguide.org/)
- [restructured text](https://docutils.sourceforge.io/rst.html)
- [pandoc](https://pandoc.org/)

per convertire:

    $ pandoc test.md -o converted.rst
    $ pandoc converted.rst -o converted.md
    $ pandoc -s converted.md -o converted.html
</pre></div>
</div>
<p>poi la convertiamo in rst e nuovamente in markdown ed html con i seguenti
comandi:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ pandoc test.md -o converted.rst
$ pandoc converted.rst -o converted.md
$ pandoc -s converted.md -o converted.html
</pre></div>
</div>
<p>I documenti sono stati convertiti, una cosa che possiamo notare è che
<cite>converted.md</cite> è un po' diverso da <cite>test.md</cite>, e questo è normale.</p>
</div>
<div class="section" id="la-prima-pagina">
<h2>La prima pagina<a class="headerlink" href="#la-prima-pagina" title="Link a questa intestazione">¶</a></h2>
<p>È giunto il momento di aggiungere contenuti alla nostra documentazione. Per
prima cosa aggiungeremo la pagina rst appena creata e per fare questo è
sufficiente modificare la pagina <cite>index.rst</cite>. Dato che ci siamo modifichiamo
un po' il testo ed inseriamo una immagine. Il nuovo testo sarà questo:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>La prima documentazione con Sphinx&#39;s
====================================

.. image:: /_static/giza.jpeg

Facciamo qualche prova con Spinx!

.. toctree::
    :maxdepth: 2
    :caption: Contenuto:

    converted.rst

Indices and tables
==================

* :ref:`genindex`
* :ref:`modindex`
* :ref:`search`
</pre></div>
</div>
<p>Il posto usuale in cui inserire le immagini e gli altri contenuti è la
cartella _static ed è quello che abbiamo fatto. Ora ricompiliamo con:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ make html
</pre></div>
</div>
<p>e facciamo il refresh della pagina.</p>
<p>Ora proviamo ad introdurre un errore, modifichiamo la riga</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">converted</span><span class="o">.</span><span class="n">rst</span>
</pre></div>
</div>
<p>con</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">converted_page</span><span class="o">.</span><span class="n">rst</span>
</pre></div>
</div>
<p>Se proviamo a ricompilare, il sistema ci avverte che c'è un errore e non fà
l'inclusione.</p>
</div>
<div class="section" id="la-documentazione-di-sphinx">
<h2>La documentazione di Sphinx<a class="headerlink" href="#la-documentazione-di-sphinx" title="Link a questa intestazione">¶</a></h2>
<p>Qual'è la documentazione Sphinx scritta in modo migliore?</p>
<p><strong>ESATTO!</strong> Avete indovinato.</p>
<p>È la documentazione di Sphinx stesso. Perciò potrebbe non essere una cattiva
idea quella di scaricare sphinx e ricompilare la documentazione allo scopo
di studiare come è stata strutturata. Per fare questo si scaricano i sorgenti
dal sito <a class="reference external" href="https://github.com/sphinx-doc/sphinx">https://github.com/sphinx-doc/sphinx</a> poi si scompatta dentro al nostro
ambiente venv e come al solito si ricompila:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ cd sphinx-3.x/doc/
$ make html
</pre></div>
</div>
<p>Ora abbiamo una versione locale della documentazione che ci sarà molto utile
per vedere come fare le cose al meglio.</p>
</div>
</div>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../index.html">Introduzione a Sphinx</a></h1>








<h3>Navigazione</h3>
<p class="caption"><span class="caption-text">Contenuto:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="premessa.html">Premessa</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Installazione di Spinx</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#installazione">Installazione</a></li>
<li class="toctree-l2"><a class="reference internal" href="#il-primo-progetto">Il primo progetto</a></li>
<li class="toctree-l2"><a class="reference internal" href="#markdown-e-pandoc">Markdown e Pandoc</a></li>
<li class="toctree-l2"><a class="reference internal" href="#la-prima-pagina">La prima pagina</a></li>
<li class="toctree-l2"><a class="reference internal" href="#la-documentazione-di-sphinx">La documentazione di Sphinx</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="scrivere.html">Scrivere la documentazione</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html">MarkDown</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html#configurazione">Configurazione</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html#documentazione-di-python">Documentazione di Python</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html#estensioni-di-sphinx">Estensioni di Sphinx</a></li>
<li class="toctree-l1"><a class="reference internal" href="glossario.html">Glossario</a></li>
<li class="toctree-l1"><a class="reference internal" href="risorse.html">Risorse</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../index.html">Documentation overview</a><ul>
      <li>Previous: <a href="premessa.html" title="capitolo precedente">Premessa</a></li>
      <li>Next: <a href="scrivere.html" title="capitolo successivo">Scrivere la documentazione</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Ricerca veloce</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Vai" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2020, Claudio Driussi.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 3.0.1</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="../_sources/pagine/installazione.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>